using System;
using System.IO;
using System.Net;
using System.Text;
using System.Diagnostics;
using System.Reflection;
using System.Configuration;
using System.Runtime.InteropServices;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using IE = Interop.SHDocVw;
using AddinExpress.IE;
using Microsoft.Win32;
//using Microsoft.SharePoint.Client;

namespace SPAuthentication
{
    /// <summary>
    /// Add-in Express for Internet Explorer Module
    /// </summary>
    [ComVisible(true), Guid("9816423A-E6FB-40EE-8994-1673351F94DC")]
    public class IEModule : AddinExpress.IE.ADXIEModule
    {
        private static string companyName = String.Empty;
        private static string productName = String.Empty;
        private string ServerUrl = String.Empty;
        private string UserName = String.Empty;
        private string Password = String.Empty;
        private string AuthType = String.Empty;
        private bool authenticationRequested = false;
        private bool authenticationPassed = false;

        private int resultMessage = 0;
        private Timer theTimer = new Timer();
        private const int WM_USER = 0x0400;
        private const int WM_AUTHENTICATION_FAILED = WM_USER + 1000;
        private const int HTTP_QUERY_CONTENT_TYPE = 1;

        public IEModule()
        {
            InitializeComponent();
            //Please write any initialization code in the OnConnect event handler
        }
 
        public IEModule(IContainer container)
        {
            container.Add(this);
 
            InitializeComponent();
            //Please write any initialization code in the OnConnect event handler
        }
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            // 
            // IEModule
            // 
            this.LoadInMainProcess = false;
            this.ModuleName = "SharePoint Authentication Example";
            this.OnConnect += new AddinExpress.IE.ADXIEConnect_EventHandler(this.IEModule_OnConnect);
            this.OnSendMessage += new AddinExpress.IE.ADXIESendMessage_EventHandler(this.IEModule_OnSendMessage);
            this.DocumentComplete2 += new AddinExpress.IE.ADXIEDocumentComplete2_EventHandler(this.IEModule_DocumentComplete2);
            this.OnResponse += new AddinExpress.IE.ADXIEResponse_EventHandler(this.IEModule_OnResponse);
            this.OnAuthenticate += new AddinExpress.IE.ADXIEAuthenticate_EventHandler(this.IEModule_OnAuthenticate);
            this.OnDataAvailable += new AddinExpress.IE.ADXIEDataAvailable_EventHandler(this.IEModule_OnDataAvailable);

        }
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void RegisterIEModule(Type t)
        {
            AddinExpress.IE.ADXIEModule.RegisterIEModuleInternal(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void UnregisterIEModule(Type t)
        {
            AddinExpress.IE.ADXIEModule.UnregisterIEModuleInternal(t);
        }
 
        [ComVisible(true)]
        public class IECustomContextMenuCommands :
            AddinExpress.IE.ADXIEModule.ADXIEContextMenuCommandDispatcher
        {
        }
 
        [ComVisible(true)]
        public class IECustomCommands :
            AddinExpress.IE.ADXIEModule.ADXIECommandDispatcher
        {
        }
 
        #endregion
 
        public IE.WebBrowser IEApp
        {
            get
            {
                return (this.IEObj as IE.WebBrowser);
            }
        }
 
        public mshtml.HTMLDocument HTMLDocument
        {
            get
            {
                return (this.HTMLDocumentObj as mshtml.HTMLDocument);
            }
        }

        private void IEModule_OnConnect(object sender, int threadId)
        {
            this.theTimer.Interval = 500;
            this.theTimer.Tick += new EventHandler(theTimer_Tick);

            NameValueCollection appSettings = ConfigurationManager.AppSettings;
            this.ServerUrl = appSettings["serverUrl"];
            this.UserName = appSettings["userName"];
            this.Password = appSettings["password"];
            this.AuthType = appSettings["authType"];
        }

        public string GetUserName()
        {
            return this.UserName;
        }

        public string GetPassword()
        {
            return this.Password;
        }

        private void IEModule_OnAuthenticate(object sender, ADXIEAuthenticateEventArgs e)
        {
            if (IsTargetDomain(e.Url))
            {
                this.authenticationPassed = false;

                if (IsLoginValid(e.Url))
                {
                    e.UserName = this.UserName;
                    e.Password = this.Password;
                    this.authenticationRequested = true;
                }
                else
                {
                    IEApp.Stop();
                    Navigate(null, "about:blank", false, "_self", null, null, false);
                    SendMessage(WM_AUTHENTICATION_FAILED, IntPtr.Zero, IntPtr.Zero);
                }

                e.Handled = true;
            }
        }

        private void IEModule_OnDataAvailable(object sender, ADXIEDataAvailableEventArgs e)
        {
            string url = e.Url;

            if (IsTargetDomain(url) && IsMDSPage(url))
            {
                string contentType = String.Empty;
                Encoding encoding = GetEncoding(e.Options, e.CodePage);

                byte[] contentTypeBytes = e.GetQueryInfo(HTTP_QUERY_CONTENT_TYPE);
                if (contentTypeBytes != null)
                    contentType = encoding.GetString(contentTypeBytes);

                if (contentType.StartsWith("text/html"))
                {
                    switch (e.DataState)
                    {
                        case ADXIEDataAvailableEventArgs.ADXIEReportDataState.DataReadyForDownload:
                            e.PreviewData = true;
                            break;
                        case ADXIEDataAvailableEventArgs.ADXIEReportDataState.DataFullyAvailable:
                            if (e.Data != null && e.Data.Length > 0)
                            {
                                string htmlSource = encoding.GetString(e.Data.GetBuffer());
                                if (InjectHTMLCode(ref htmlSource))
                                {
                                    e.Data.SetLength(0);
                                    byte[] bytes = encoding.GetBytes(htmlSource);
                                    e.Data.Write(bytes, 0, bytes.Length);
                                    e.UpdateCacheFile(false);
                                }

                                this.authenticationPassed = false;
                            }
                            break;
                    }
                }
            }
        }

        private void IEModule_OnResponse(object sender, ADXIEResponseEventArgs e)
        {
            if (this.authenticationRequested)
            {
                this.authenticationRequested = false;

                if (e.ResponseCode == 200)
                    this.authenticationPassed = true;
                else if (e.ResponseCode == 401)
                    SendMessage(WM_AUTHENTICATION_FAILED, IntPtr.Zero, IntPtr.Zero);
            }
        }

        private void theTimer_Tick(object sender, EventArgs e)
        {
            this.theTimer.Enabled = false;
            SendMessage(this.resultMessage, IntPtr.Zero, IntPtr.Zero);
        }

        private void IEModule_OnSendMessage(ADXIESendMessageEventArgs e)
        {
            if (e.Message == WM_AUTHENTICATION_FAILED)
            {
                if (IEApp.ReadyState == IE.tagREADYSTATE.READYSTATE_COMPLETE)
                {
                    MessageBox.Show(this, "The wrong login and/or password.", this.ModuleName, MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                else
                {
                    this.resultMessage = WM_AUTHENTICATION_FAILED;
                    this.theTimer.Enabled = true;
                }
            }
        }

        private bool InjectHTMLCode(ref string source)
        {
            int pos = source.IndexOf("AjaxDelta=1", StringComparison.InvariantCultureIgnoreCase);
            if (pos > 0 && source.IndexOf("http_auth_bho") == -1)
            {
                string openStatement;
                string initStatement;
                int startOpenPos = pos - 1;
                int endOpenPos = pos + 1;

                while (source[startOpenPos] != ';' && startOpenPos > 0) startOpenPos--;
                while (source[endOpenPos] != ';' && endOpenPos < source.Length) endOpenPos++;

                if (startOpenPos > 0 && endOpenPos < source.Length)
                {
                    startOpenPos++;
                    openStatement = source.Substring(startOpenPos, endOpenPos - startOpenPos + 1);
                    openStatement = openStatement.Substring(0, openStatement.Length - 2) + ", http_auth_bho.GetUserName(), http_auth_bho.GetPassword());";

                    string delay_Statement = "\r\nSP.SOD.executeOrDelayUntilEventNotified(function () {";

                    endOpenPos++;
                    source = source.Substring(0, startOpenPos) + delay_Statement + openStatement + source.Substring(endOpenPos, source.Length - endOpenPos);

                    int sendEndPos = source.IndexOf(".send", startOpenPos);
                    if (sendEndPos > -1)
                    {
                        while (source[sendEndPos] != ';' && sendEndPos < source.Length) sendEndPos++;

                        if (sendEndPos < source.Length)
                        {
                            sendEndPos++;
                            source = source.Substring(0, sendEndPos) + " }, \"http_auth_bho_event\");\r\n" + source.Substring(sendEndPos, source.Length - sendEndPos);

                            int scriptPos = source.IndexOf("<script", 0, StringComparison.InvariantCultureIgnoreCase);
                            if (scriptPos > -1)
                            {
                                source = source.Substring(0, scriptPos) +
                                    "<script type=\"text/javascript\">\r\nvar http_auth_bho = null;\r\n</script>" + source.Substring(scriptPos, source.Length - scriptPos);

                                pos = source.IndexOf("/_layouts/15/init.js", 0, StringComparison.InvariantCultureIgnoreCase);
                                if (pos > 0)
                                {
                                    startOpenPos = pos - 1;
                                    endOpenPos = pos + 1;

                                    while (source[startOpenPos] != '<' && startOpenPos > 0) startOpenPos--;

                                    if (startOpenPos > 0 && endOpenPos < source.Length)
                                    {
                                        endOpenPos = source.IndexOf("</script>", startOpenPos);
                                        if (endOpenPos > -1)
                                        {
                                            endOpenPos += 9;

                                            initStatement = source.Substring(startOpenPos, endOpenPos - startOpenPos);
                                            source = source.Substring(0, startOpenPos) + source.Substring(endOpenPos, source.Length - endOpenPos);
                                            source = source.Substring(0, scriptPos) + "\r\n" + initStatement + "\r\n" + source.Substring(scriptPos, source.Length - scriptPos);

                                            return true;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }

            return false;
        }

        private Encoding GetEncoding(ADXIEBindInfoOptions options, ADXIEBICodepage codepage)
        {
            if ((options & ADXIEBindInfoOptions.EnableUTF8) > 0)
                return Encoding.UTF8;

            switch (codepage)
            {
                case ADXIEBICodepage.UTF7:
                    return Encoding.UTF7;
                case ADXIEBICodepage.UTF8:
                    return Encoding.UTF8;
                default:
                    return Encoding.Default;
            }
        }

        private Encoding GetEncoding(ADXIEBindInfo binfo)
        {
            return GetEncoding(binfo.Options, binfo.CodePage);
        }

        private ICredentials CreateCredentials(string siteurl, string username, string password, string authtype)
        {
            NetworkCredential cred;

            if (username.Contains(@"\"))
            {
                string domain = username.Substring(0, username.IndexOf(@"\"));
                username = username.Substring(username.IndexOf(@"\") + 1);
                cred = new System.Net.NetworkCredential(username, password, domain);
            }
            else
            {
                cred = new System.Net.NetworkCredential(username, password);
            }

            CredentialCache cache = new CredentialCache();
            if (authtype.Contains(":"))
                authtype = authtype.Substring(authtype.IndexOf(":") + 1);
            cache.Add(new Uri(siteurl), authtype, cred);

            return cache;
        }

        private bool IsLoginValid(string url)
        {
            HttpWebResponse response = null;

            try
            {
                HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
                request.Credentials = CreateCredentials(url, this.UserName, this.Password, this.AuthType);
                request.KeepAlive = true;

                response = (HttpWebResponse)request.GetResponse();
                return (response.StatusCode == HttpStatusCode.OK);
            }
            catch (Exception)
            {
            }
            finally
            {
                if (response != null)
                    response.Close();
            }

            return false;
        }

        private bool IsTargetDomain(string url)
        {
            return (!String.IsNullOrEmpty(url)) && (!String.IsNullOrEmpty(this.ServerUrl)) && url.StartsWith(this.ServerUrl, StringComparison.InvariantCultureIgnoreCase);
        }

        private bool IsMDSPage(string url)
        {
            return (!String.IsNullOrEmpty(url)) && url.Contains("/_layouts/15/start.aspx");
        }

        internal void Navigate(IE.WebBrowser browser, string urlString, bool newWindow, string targetFrameName, byte[] postData, string headers, bool tabActivate)
        {
            object uRL = urlString;
            // BrowserNavConstants: navOpenInNewWindow=1, navOpenInNewTab=0x0800
            object flags = (newWindow ? 1 : (this.IEVersion >= 7 ? (targetFrameName == "_self" ? 0 : 0x0800) : 0));
            // The name of the frame: _blank, _parent, _self, _top or a named HTML frame.
            object obj4 = targetFrameName;
            // The data sent to the server as part of a HTTP POST transaction.
            object obj5 = postData;
            // Additional HTTP headers to send to the server
            object obj6 = headers;

            PerformNavigate(browser, ref uRL, ref flags, ref obj4, ref obj5, ref obj6, tabActivate);
        }

        private void PerformNavigate(IE.WebBrowser browser, ref object URL, ref object flags, ref object targetFrameName, ref object postData, ref object headers, bool tabActivate)
        {
            try
            {
                // if the browser is 'null', use the local reference to the browser.
                if (browser == null)
                    this.IEApp.Navigate2(ref URL, ref flags, ref targetFrameName, ref postData, ref headers);
                else
                    browser.Navigate2(ref URL, ref flags, ref targetFrameName, ref postData, ref headers);

                // If true, make the current tab visible.
                if (tabActivate) TabActivate();
            }
            catch (COMException exception)
            {
                // Error code -2147023673: Operation was canceled by the user.
                if (exception.ErrorCode != -2147023673)
                    throw;
            }
        }

        private void IEModule_DocumentComplete2(object pDisp, string url, bool rootDocLoaded)
        {
            if (IsTargetDomain(url) && IsMDSPage(url) && (!this.authenticationPassed))
            {
                try
                {
                    var requestUrlFull = url;

                    var parts = url.Split('#'); 
                    if (parts.Length >= 2)
                    {
                        var pos = parts[0].IndexOf("/_layouts/15/start.aspx");
                        if (pos != -1)
                        {
                            var hPos = url.IndexOf('#');
                            requestUrlFull = parts[0].Substring(0, pos) + parts[1];
                        }
                    }

                    object scriptEngine = HTMLDocument.Script;
                    if (scriptEngine != null)
                    {
                        scriptEngine.GetType().InvokeMember("http_auth_bho", BindingFlags.SetProperty, null, scriptEngine, new object[] { this });

                        if (!IsLoginValid(requestUrlFull))
                        {
                            IEApp.Stop();
                            Navigate(null, "about:blank", false, "_self", null, null, false);
                            SendMessage(WM_AUTHENTICATION_FAILED, IntPtr.Zero, IntPtr.Zero);
                            return;
                        }

                        this.authenticationPassed = true;
                        this.HTMLDocument.parentWindow.execScript("SP.SOD.notifyEventAndExecuteWaitingJobs(\"http_auth_bho_event\");", null);
                    }
                }
                catch (Exception)
                {
                }
            }
        }

    }
}

